#define NAME(b) kpf_##b
// change here  ^^^ to automagically rename all funcs :)
				
//#include "errno.h"
#define EFAULT 111

#define PREFETCH(a) prefetchnta a
//#define PREFETCH(a) prefetch a
//#define PREFETCH(a)

#define ITER_BITS 5             /* ...5,6,7 - ...32,64,128 bytes */
                                // tweak unrolled loop too...
#define ITER_SZ (1<<ITER_BITS)
#define ITER_MSK ((1<<ITER_BITS)-4)

/*
unsigned int csum_partial_copy_generic (const char *src, char *dst,
				  int len, int sum, int *src_err_ptr, int *dst_err_ptr)
 */ 

/*
 * Copy while checksumming, otherwise like csum_partial
 *
 * The macros SRC and DST specify the type of access for the instruction.
 * thus we can call a custom exception handler for all access types.
 *
 */

#define SRC(y...) \
	9999: y;			\
	.section __ex_table, "a";	\
	.long 9999b, 6001f	;	\
	.previous

#define DST(y...) \
	9999: y;			\
	.section __ex_table, "a";	\
	.long 9999b, 6002f	;	\
	.previous

#define ROUND(x) \
SRC(	movq	x(%esi), %mm0	);	\
	adcl	x(%esi), %eax	;	\
	adcl	x+4(%esi), %eax	;	\
DST(	movntq	%mm0, x(%edi)	);
// we don't need SRC() around 2nd and 3rd commands
// (exception, if any, would be catched by 1st one)
		
.text
.align 4
.globl NAME(copy)

NAME(copy):

#define ARGBASE 12

	pushl	%edi
	pushl	%esi
	pushl	%ebx

	movl	ARGBASE+16(%esp), %eax	# sum
	movl	ARGBASE+12(%esp), %ecx	# len
	movl	ARGBASE+4(%esp), %esi	# src
	movl	ARGBASE+8(%esp), %edi	# dst

	testl	$2, %edi	# Check alignment
	jnz	5500f		# align to dword
1:
	movl	%ecx, %edx
	shrl	$ITER_BITS, %ecx
	jz	20f

# "big chunks" loop 
	PREFETCH((%esi))	# Initiate prefetch
	PREFETCH(64(%esi))
	PREFETCH(128(%esi))
	PREFETCH(192(%esi))
	subl	$108, %esp
	fsave	(%esp)		# save FPU - we will use MMX...
	fwait
	testl	%esi, %esi	# clears CF
10:
	PREFETCH(256(%esi))
	ROUND(0)
	ROUND(8)
	ROUND(16)
	ROUND(24)
/*	ROUND(32)
	ROUND(40)
	ROUND(48)
	ROUND(56)*/
	lea	ITER_SZ(%esi), %esi
	lea	ITER_SZ(%edi), %edi
	//dec	%ecx
	//jnz	10b
	loop	10b
	adcl	$0, %eax

	sfence			# clean up MMX
	frstor	(%esp)
	addl	$108, %esp

# loop for dwords
20:	movl	%edx, %ecx
	andl	$ITER_MSK, %edx
	jz	40f
	shrl	$2, %edx	# this also clears CF
30:
SRC(	movl	(%esi), %ebx	)
	adcl	%ebx, %eax
DST(	movl	%ebx, (%edi)	)
	lea	4(%esi), %esi
	lea	4(%edi), %edi
	dec	%edx
	jnz	30b
	adcl	$0, %eax
	
# last 1, 2 or 3 bytes
40:	andl	$3, %ecx
	jz	70f
	cmpl	$2, %ecx
	jb	50f
SRC(	movw	(%esi), %cx	)
DST(	movw	%cx, (%edi)	)
	je	60f
	leal	2(%esi), %esi
	leal	2(%edi), %edi
	shll	$16,%ecx
50:
SRC(	movb	(%esi), %cl	)
DST(	movb	%cl, (%edi)	)
60:	addl	%ecx, %eax
	adcl	$0, %eax
70:
5000:
	popl	%ebx
	popl	%esi
	popl	%edi
	ret


# Align to dword and get back
//5500:	sub	$2, %ecx	# FIXME: BUG!!! ecx == -1
//	jb	50b		# TODO: make this bug catchable!
5500:	dec	%ecx
	jz	50b
	dec	%ecx
SRC(	movw	(%esi), %bx	)
	addl	$2, %esi
DST(	movw	%bx, (%edi)	)
	addl	$2, %edi
	addw	%bx, %ax
	adcl	$0, %eax
	jmp	1b


# Exception handler:
.section .fixup, "ax"							

6001:
	movl	ARGBASE+20(%esp), %ebx	# src_err_ptr
	movl	$-EFAULT, (%ebx)

	# zero the complete destination - computing the rest
	# is too much work 
	movl	ARGBASE+8(%esp), %edi	# dst
	movl	ARGBASE+12(%esp), %ecx	# len
	xorl	%eax,%eax
	rep; stosb
	jmp	5000b

6002:
	movl	ARGBASE+24(%esp), %ebx	# dst_err_ptr
	movl	$-EFAULT,(%ebx)
	jmp	5000b

.previous
